
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "module3.h"

char *version = "CIS 301 PIC 17C42 Assembler\n"; 

opcode_t  ot[] ={{"equ", EQU},
                 {"org", ORG},  
                 {"list", LIST},  
                 {"nolist", NOLIST},  
                 {"addlw", 0XB100,{{8,0}}},  /*arithmetic & logic*/
		 {"addwf", 0X0E00,{{8,0},{1,8}}},
		 {"addwfc", 0X1000,{{1,8},{8,0}}},
		 {"andlw", 0XB500,{{8,0}}},
		 {"andwf", 0X0A00,{{8,0},{1,8}}},
		 {"clrf", 0X2800,{{8,0},{1,8}}},
		 {"comf", 0X1200,{{8,0},{1,8}}},
		 {"daw", 0X2E00,{{8,0},{1,8}}},
		 {"decf", 0X0600,{{8,0},{1,8}}},
		 {"incf", 0X1400,{{8,0},{1,8}}},
		 {"iorlw", 0XB300,{{8,0}}},
		 {"iorwf", 0X0800,{{8,0},{1,8}}},
		 {"movlw", 0XB000,{{8,0}}},
		 {"negw", 0X2C00,{{8,0},{1,8}}},
		 {"rlcf", 0X1A00,{{8,0},{1,8}}},
		 {"rlncf", 0X2200,{{8,0},{1,8}}},
		 {"rrcf", 0X1800,{{8,0},{1,8}}},
		 {"rrncf", 0X2000,{{8,0},{1,8}}},
		 {"setf", 0X2A00,{{8,0},{1,8}}},
		 {"sublw", 0XB200,{{8,0}}},
		 {"subwf", 0X0400,{{8,0},{1,8}}},
		 {"subwfb", 0X0200,{{8,0},{1,8}}},
		 {"swapf", 0X1C00,{{8,0},{1,8}}},
		 {"xorlw", 0XB400,{{8,0}}},
		 {"xorwf", 0X0C00,{{8,0},{1,8}}},   
		 {"movfp", 0X6000,{{8,0},{5,8}}},  /*data move*/
		 {"movlb", 0XB800,{{8,0}}},
		 {"movpf", 0X4000,{{8,0},{5,8}}},
		 {"movwf", 0X0100,{{8,0}}},
		 {"tablrd", 0XA800,{{1,9},{1,8},{8,0}}},
		 {"tablwt", 0XAC00,{{1,9},{1,8},{8,0}}},
		 {"tlrd", 0XA000,{{1,9},{8,0}}},   /*?*/
		 {"tlwt", 0XA400,{{1,9},{8,0}}},   /*?*/ 
		 {"call",0XE000,{{13,0}}},     /*program control*/
		 {"cpfseq",0X3100,{{8,0}}},
		 {"cpfsgt",0X3200,{{8,0}}},
		 {"cpfslt",0X3000,{{8,0}}},
		 {"decfsz",0X1600,{{8,0},{1,8}}},
		 {"dcfsnz",0X2600,{{8,0},{1,8}}},
		 {"goto",0XC000,{{13,0}}},
		 {"incfsz",0X1E00,{{8,0},{1,8}}},
		 {"infsnz",0X2400,{{8,0},{1,8}}},
		 {"lcall",0XB700,{{8,0}}},
		 {"retfie",0X0005,{{0,0}}},
		 {"retlw",0XB600,{{8,0}}},
		 {"return",0X0002,{{0,0}}},
		 {"tstfsz",0X3300,{{8,0}}},
		 {"bcf",0X8800,{{8,0},{3,8}}},
		 {"bsf",0X8000,{{8,0},{3,8}}},
		 {"btfsc",0X9800,{{8,0},{3,8}}},
		 {"btfss",0X9000,{{8,0},{3,8}}},
		 {"btg",0X38000,{{8,0},{3,8}}},
		 {"clrwdt",0X0004,{{0,0}}},
		 {"nop",0X0000,{{0,0}}},
		 {"sleep",0X0003,{{0,0}}},
		 {0,0}};



#if 0		 
main()
{
printf("Enter the opcode\n");
gets(opcode);
opcode_lookup(opcode);
}
#endif

struct opcode_table *opcode_lookup(char *opcode) 
{
struct opcode_table *ot_ptr;
char *op;


   for(op=opcode;*op;op++)      /*forces opcode to lower case*/
     *op=tolower(*op);
     
   for(ot_ptr=ot;ot_ptr->opcode_name;ot_ptr++) { 
      if (!strcmp(opcode,ot_ptr->opcode_name)) {
 	return ot_ptr;
      }
   }
   return NULL;
}    
    			 
