#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "module2.h"
#include "module3.h"
#include "module4.h"
#include <stdlib.h>

extern char *version;

FILE *listfile;

char *debug;

char *add_extension(char *fn,char *ext);

#define DEBUG(module) strchr(debug,module)

char *label, *opcode, *operands;
unsigned long loc=0;
int write_list = 1;

main(int argc,char **argv)

{
   
   char  line[80],*tks[4],copy[80],*debugstr;
   int nt,tp;
   node_p res;
   opcode_p num_opcode;
   FILE *infile;
   unsigned ml_opcode;

   fprintf(stderr,version);
   fprintf(stderr,"Chelito DeSilva\n");
   fprintf(stderr,"(minor additions by Byron A. Jeff)\n");
   fprintf(stderr,"\n");
   fprintf(stderr,"Department of Computer and Information Sciences\n");
   fprintf(stderr,"Clark Atlanta University");
   fprintf(stderr,"\n");
   fprintf(stderr,"(c) December 1994\n");
   fprintf(stderr,"\n");

   if (argc != 2) {
      printf("Usage: asm17c42 <filename>\n");
      exit(1);
   }
   
   if ((infile = fopen(argv[1],"r")) == NULL) {
      printf("Error: Input file not found. \n");
      printf("Usage: asm17c42 <filename>\n");
      exit(1);
   }

   if (!(debug = getenv("ASM17C42")))
      debug = "";

   listfile = fopen(add_extension(argv[1],"lst"),"w");

   hash_init();
   
   while (1) {
      
      if (fgets(line,80,infile) == NULL)
         break;

      strcpy(copy,line);

      nt=tokenize(line,tks);

      if (!nt)
         continue;

      identify(tks,nt); 

      if (opcode) {   
         if ((num_opcode=opcode_lookup(opcode)) == NULL) {
            fprintf(stderr,"Unknown opcode %s\n",opcode);
            exit(1);
         }
         if (num_opcode->opcode_value > PSEUDO_OP) {
            if (write_list) 
               fprintf(listfile,"%04x:\t\t%s\n",loc,copy);
            switch(num_opcode->opcode_value) {
               case EQU: if (!operands) {
                            fprintf(stderr,"EQU must have operand!\n");
                            exit(1);
                         }
                         do_backpatch(label,get_value(operands),
                                      write_list ? listfile : (FILE *) 0);
                         break;
               case ORG: if (!operands) {
                            fprintf(stderr,"ORG must have operand!\n");
                            exit(1);
                         }
                         loc = get_value(operands);
                         break;
               case LIST: write_list = 1;
                          break;
               case NOLIST: write_list = 0;
                            break;
               default:  fprintf(stderr,"unknown pseudo-op: %s",opcode);
                         exit(1);
            }             
            continue;
         }
      }
         
      if (label) {
            do_backpatch(label,loc,
               write_list ? listfile : (FILE *) 0);
      }     
      
      if (opcode) {   
    
         ml_opcode = operands ? 
                     operand_merge(operands,num_opcode) : 
                     num_opcode->opcode_value;
         write_word(ml_opcode);
         
         if (write_list)
            fprintf(listfile,"%04x: %04x \t%s",loc,ml_opcode,copy);
         loc++;
      }
      else
            fprintf(listfile,"%04x:\t\t%s",loc,copy);
   }         
   write_ml_file(add_extension(argv[1],"obj"));
}

char *add_extension(char *fn,char *ext)
{
   static char newfn[80];
   char *p;

   if (p=strchr(fn,'.')) 
      *p = 0;

   sprintf(newfn,"%s.%s",fn,ext);
 
   if (p)
      *p = '.';

   if (DEBUG('a'))
      fprintf(stderr,"New file name: %s\n",newfn);
   return newfn;
}
 

