/*CIS 301*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "module2.h"
#define SIZE 383

node_p hash_table[SIZE];
#if 0
main()
{

   char name[10],val[15];
   long value;
   node_p res;
   int quit = 0;

   hash_init();
   while (!quit) {
      printf("Enter command> ");
      gets(name);
      switch (tolower(*name)) {
         case 'p': hash_print();
                   break;
         case 'l': printf("Enter name> ");
                   gets(name);
                   res = hash_lookup(name);   
                   if (res) 
                      printf("name: %s value: %ld\n",res->name,res->val);
                   else
                      printf("%s not found\n",name);
                   break;
         case 'i': printf("Enter name> ");
                   gets(name);
                   printf("Enter value> ");
                   gets(val);
                   value = atoi(val);
                   hash_insert(name,value);
                   break;
         case 'h':
         case '?': printf("Commands: (P)rint, (I)insert, (L)ookup, (Q)uit\n");
                   break;
         case 'q': quit = 1;
                   break;
         default : printf("Error: Use ? for help.\n");
                   break;
      }
   }
}
#endif
void hash_init() /*initializes the hash table*/
{
   int i;

   for(i=0; i<SIZE; i++) { 
      hash_table[i] =(node_p)0; 
#ifdef DEBUG_HASH
      printf("hash_table[%d]=%s\n",i,hash_table[i]);
#endif
   }
}


int hash(char *name) /*calculates hash value*/
{
   int sum;

   for(sum=0; *name; name++) 
       sum+=*name;
   /*printf("bucket number is %ld\n",(sum % SIZE));*/
   return sum % SIZE;
}

 
node_p hash_insert(char *name, long val) /*inserts another node to the list*/
{
   int bucket;
   node_p tmp;

   if (tmp = hash_lookup(name)) 
      return tmp;

   tmp=(node_p)malloc(sizeof(node_t));

   tmp->name=strdup(name);
   tmp->val=val;
   tmp->backpatches = (backpatch_p) 0;

   bucket=hash(name);
   tmp->next=hash_table[bucket];
   hash_table[bucket]=tmp;
  
   return tmp;
}

 
void hash_print()
{
   int i;
   node_t *np;
 
   printf("\t Hash Table\n");
   for(i=0; i<SIZE; i++) { 
      np=hash_table[i];
      printf("hash_table[%d]= ",i);
      if(hash_table[i]==0)
      	printf("   Empty");
      else	
      for(; np!=0; np=np->next)
         printf("%s  %ld  ",np->name,np->val);
      printf("\n");  
   }
 }
 
   
node_p hash_lookup(char *name)
{
 int i;
 node_t *np;

     
   for(np=hash_table[hash(name)]; np!=0; np=np->next)
      if(strcmp(name,np->name)==0) {
     	 /* printf("%s\n", np->name);*/
     	   return np;
      }
     	   
   return NULL;
 }
        
void add_backpatch(char *name,int loc,operand_p pos)
{
   node_p tmp;
   backpatch_p btmp;

   /* Either add or retrieve the entry under name */
   tmp = hash_insert(name,0L);
   btmp = (backpatch_p) malloc(sizeof(backpatch_t));
   btmp->address = loc << 1;
   btmp->pos = pos;
   btmp->next = tmp->backpatches;
   tmp->backpatches = btmp;
}

void do_backpatch(char *name,long val,FILE *listfile)
{
   node_p tmp;
   backpatch_p btmp,new_btmp;
   unsigned instr;
   unsigned tval;

   /* Either add or retrieve the entry under name */
   tmp = hash_insert(name,val);

   if (tmp->backpatches) { /* The only way that a node was already there */
      tmp->val = val; /* Make sure to update the current value */
      for(btmp=tmp->backpatches;btmp;btmp = new_btmp) {
         instr = read_word(btmp->address);
         tval = (val & ((1 << btmp->pos->width) - 1)) << btmp->pos->shift;
         write_word_to_address(btmp->address,instr|tval);
         if (listfile)
            fprintf(listfile,"%04x: backpatch: updating %04x to %04x\n",
                    btmp->address >> 1,instr,instr|tval);
         new_btmp = btmp->next;
         free(btmp);
      }
      tmp->backpatches = (backpatch_p) 0;
   }
}

         
