/*Chelito DeSilva*/
/*November 1994*/
/*CIS 301*/

#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include "module2.h"
#include "module3.h"
#include "module4.h"

#define NUMBER 1
#define LABEL  2
#define REG    3
#define BINNUM 4

#define DEBUGM4() strchr(debug,'4')

static int must_backpatch = 0;
extern int loc;
extern char *debug;

int op_tokenize(char *operands, char *optokens[]);
int classify(char *single_operand);
unsigned get_value(char *single_operand);
char *number, *label, *reg;

unsigned operand_merge(char *operands,opcode_p opcode)
{
   char *optks[4],**tok;
   unsigned sum=0,val;
   int i, mask;
      
   sum=opcode->opcode_value;
   op_tokenize(operands,optks);
 
   for(i=0,tok=optks;*tok;tok++,i++) {
      val = get_value(*tok);
      if (must_backpatch) {
         add_backpatch(*tok,loc,&opcode->pos[i]);
         must_backpatch = 0;
      }      
      
      mask=(1<<opcode->pos[i].width)-1;
      if (val > mask)
         printf("WARNING:operand %s too large\n",*tok);   
      
      val &= mask;

      sum += val<<opcode->pos[i].shift;
         
   }
   return sum;
}
/*tokenize breaks a line up into tokens, each separated by a null*/
int op_tokenize(char *operands, char *optokens[])
{
   char **t;
        
        t=optokens;
         
      while (1) {    
           if (!*operands) {
              *t = 0;                    /*check for end of line*/
              return t-optokens;
           }

	   *t++ = operands;              
           
           for(; *operands!=','&& *operands; operands++); 
                                                  /* finds end of token*/

           if (!*operands) {
              *t = 0;                    /*check for end of line*/
              return t-optokens;
           }
           *operands++ = 0;                /*places null at end of ea. token*/
            
      }
}

/*classify determines the type of operand.(1=number, 2=label, 3=register)*/
int classify(char *single_operand)
{
  if (isdigit(*single_operand)) 
     return *(single_operand+1) == 'b' ? BINNUM : NUMBER;
           
  if (*single_operand == 'f' && isdigit(*(single_operand+1))) 
      return REG;
  
   return LABEL;
}

/*get_value gets the value of the operand*/
unsigned get_value(char *single_operand)
{
     node_p hashval;
 
     switch (classify(single_operand)) {
        case NUMBER:   
           return strtol(single_operand,NULL,0);
        case BINNUM:   
           return strtol(single_operand+2,NULL,2);
        case LABEL:  
           hashval = hash_lookup(single_operand);
           if (!hashval || hashval->backpatches) {
              if (DEBUGM4()) {
                 fprintf(stderr,"Backpatch request: %s at %04x\n",
                     single_operand,loc);
              }
              must_backpatch = 1;
           }
           else {
               if (DEBUGM4()) 
                  fprintf(stderr,"hash lookup: name :%s value: %lx\n",
                     hashval->name,hashval->val);
           }
           return hashval ? hashval->val : 0;
        case REG: 
           return strtol(single_operand+1,NULL,0);
     }
}         
