#include <stdio.h>
#include <ctype.h>
#include <string.h>

FILE    *Sfile;
int     checksum;

#define S1MAX   0xFFFF
#define S2MAX   0xFFFFFF

fatal(char *s)
{
   fprintf(stderr,"Error: %s\n",s);
   exit(0);
}

srecinit(s)
char *s;
{
	if( (Sfile = fopen(s,"w")) == NULL )
		fatal("Can't open output file");
	srec('0',(long) strlen(s),0L,s);
}

srecdata(count,addr,buf)
int count; unsigned long addr; char *buf;
{
	char	type;

	if( addr <= S1MAX )
		type = '1';
	else if( addr <= S2MAX )
		type = '2';
	else
		type = '3';
	srec(type,(long)count,addr,buf);
}

srecend(addr)
long addr;
{
	char	type;
        unsigned long baj_addr;

        baj_addr = (unsigned long) addr;

	if( baj_addr <= S1MAX )
		type = '9';
	else if(baj_addr <=S2MAX)
		type = '8';
	else
		type = '7';
	srec(type,0L,baj_addr,&type);
	fclose(Sfile);
}

static int alen[10] = { 2, 2, 3, 4, 0, 0, 0, 4, 3, 2 };

srec(type,count,addr,buf)
char type; long count; unsigned long addr; char *buf;
{

	fprintf(Sfile,"S%c",type);    /* record header */
	checksum = 0;
	put2hex((int) (count+alen[type-'0']+1));
	switch(alen[type-'0']){
	case 4:
		put2hex((int) (addr>>24));
	case 3:
		put2hex((int) (addr>>16));
	case 2:
		put2hex((int) (addr>>8));
		put2hex((int) (addr));
		}
	while(count--)
		put2hex(*buf++);

	put2hex(~checksum);
	fprintf(Sfile,"\n");
}

/*
 *      put2hex --- print low byte of integer in hex
 *
 *      Also, update checksum
 */

static char hexstr[] = "0123456789ABCDEF";

put2hex(b)
int b;
{

	b &= 0xFF;
	fprintf(Sfile,"%c%c",hexstr[(b>>4)&0xF],hexstr[b&0xF]);
	checksum += b;
}
